// demonstration of chaotic behavior with a logistic map
// (as described in Melanie Mitchell's book "Complexity")

int num = 3;
float x = 0;
float y = 100;
float oldX = 0;
float oldY = 100;
float R = 3.8;   // for "environmental variables"
float d = .2;    // Below 1.0 for interesting behaviors

void setup() {
  size(800, 400);
  stroke(150, 200, 200, 100);
  strokeWeight(5);
  smooth();
  background(0);
  
  frameRate(10);
}

void draw() {
  
 // Calculate
    d = (R*d)*(1-d);

 // Scale
    y = 40 + (d * 250); // Change is scaled to make more visible
    x = x + 9; 
    println(d); 
 // Draw
 //  line(oldX, oldY, x, y);
     ellipse(oldX, oldY, 8.0, 8.0);
 
 // update time step
    oldX = x;
    oldY = y;
    
  //-- run different color changed by a 10 millionth
  if(x > 800) {
    stroke(255, 50, 10, 100); // change color
    oldX = 0;
    x = 0;
    d = .2000001;
   }
}
